=== include/CMakeLists.txt ===
add_subdirectory("libdnf5")
add_subdirectory("libdnf5-cli")
