=== libdnf5-plugins/CMakeLists.txt ===
set(CMAKE_CXX_VISIBILITY_PRESET hidden)
set(CMAKE_C_VISIBILITY_PRESET hidden)

add_subdirectory("actions")
add_subdirectory("appstream")
add_subdirectory("expired-pgp-keys")
add_subdirectory("python_plugins_loader")
add_subdirectory("rhsm")
add_subdirectory("local")
