=== debian/changelog ===
dnf5 (5.4.0.0-1) unstable; urgency=medium

  * Update upstream source from tag 'upstream/5.4.0.0'
  * Add dependency on libacl

 -- Luca Boccassi <bluca@debian.org>  Thu, 19 Feb 2026 14:29:50 +0000
