=== debian/rules ===
#!/usr/bin/make -f

export DEB_PYTHON_INSTALL_LAYOUT=deb
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk
include /usr/share/debhelper/dh_package_notes/package-notes.mk

%:
	dh "${@}"

override_dh_auto_configure:
	dh_auto_configure -- \
		-DWITH_MAN:BOOL=$(if $(filter nodoc,$(DEB_BUILD_PROFILES)),OFF,ON) \
		-DWITH_TESTS:BOOL=$(if $(filter nocheck,$(DEB_BUILD_PROFILES)),OFF,ON) \
		-DWITH_DNF5_OBSOLETES_DNF:BOOL=OFF \
		-DWITH_PERL5:BOOL=OFF \
		-DWITH_RUBY:BOOL=OFF \
		-DWITH_PYTHON3:BOOL=OFF \
		-DWITH_PLUGIN_MANIFEST:BOOL=OFF \
		-DWITH_HTML:BOOL=OFF

ifeq (,$(findstring nodoc,$(DEB_BUILD_PROFILES)))
execute_after_dh_auto_build:
	dh_auto_build -- doc-man
endif
